# Online Appendix

This is the online appendix to the paper **Domain-Specific Heuristics in Answer Set Programming: A Declarative Non-Monotonic Approach** by Richard Comploi-Taupe, Gerhard Friedrich, Konstantin Schekotihin, and Antonius Weinzierl.

## Domains

The online appendix contains encodings and instances for the domains and search problems used for our experiments.

### The House Reconfiguration Problem (HRP)

Encodings and instances are located in the subdirectory `hrp`.

Original sources:
 * Friedrich, Gerhard; Ryabokon, Anna; Falkner, Andreas A.; Haselböck, Alois; Schenner, Gottfried; Schreiner, Herwig (2011): (Re)configuration using Answer Set Programming. Proceedings of the IJCAI 2011 Workshop on Configuration (ConfWS 2011). Available from <http://ceur-ws.org/Vol-755/paper03.pdf>
 * Ryabokon, Anna (2015): Knowledge-Based (Re)Configuration of Complex Products and Services. Dissertation. Alpen-Adria-Universität, Klagenfurt. Available at <https://netlibrary.aau.at/urn:nbn:at:at-ubk:1-26431>

Encoding `encoding-aspcore2.asp` has been revised and extended by Richard Comploi-Taupe.
Based on the original encoding, encodings for Alpha (`encoding-alpha.asp`) and Clingo with domain-specific heuristics (`encoding-hclingo.asp`) as well es Alpha with Clingo-like heuristics (`encoding-alpha-clingoheu.asp`) have been designed as described in our paper.

Instances have been generated as described in our paper.

### The Partner Units Problem (PUP)

Encodings and instances are located in the subdirectory `pup`.

The ASP-Core-2 encoding (`encoding-aspcore2.asp`) is the _novel_ one from the Fifth ASP Competition (<https://www.mat.unical.it/aspcomp2014/FrontPage#Participants.2C_Encodings.2C_Instance_Sets>).
The Alpha encoding (`encoding-alpha.asp`) is based on that encoding and also incorporates ideas from a QuickPup encoding by Erich Teppan (<http://isbi.aau.at/hint/ascass>).
The encoding for Clingo with domain-specific heuristics (`encoding-hclingo.asp`) has been designed by Konstantin Schekotihin.
Based on the latter, an encoding for Alpha with Clingo-like heuristics (`encoding-alpha-clingoheu.asp`) has also been created.

Instances in `instances_aspcomp` are all 18 instances from the [ASP competitions](https://www.mat.unical.it/aspcomp2011/FinalProblemDescriptions/PartnerUnitsPolynomial) that are satisfiable, belong to the subclass of PUP instances that can be polynomially decided, and in which the input graphs are connected.
Instances in `instances_generated` have been generated as described in our paper.

### Pathfinding with A*

Encodings and instances are located in the subdirectory `a-star`.
Subdirectory `a-star/pathfinding` is specific to Pathfinding and `a-star/routing` is specific to real-world routing.

Encodings have been created by Richard Comploi-Taupe.

Instances have been generated as described in our paper.

## Binaries

The Alpha binaries used for the experiments can be found on our [website](https://git-ainf.aau.at/DynaCon/website/tree/master/supplementary_material/2022_JAIR_Domain-Specific_Heuristics).
Source code and documentation can be found on [GitHub](https://github.com/alpha-asp/Alpha/tree/domspec_heuristics_extended).